Subject: Re: bug#44825: Error in reporting guix deploy error

From: Christopher Lemmer Webber <[email-masked]>
Date: Mon, 23 Nov 2020 13:45:52 -0500

By the way, I did pinpoint out what caused the failure in *deploying*,
but not what caused the error message to not format correctly.

The mistake was:

(modify-services  %desktop-services
        (guix-service-type config =>
                          (guix-configuration
                           (inherit config)
                           (authorized-keys
-                           (append (list (local-file "twig-guix-signing-key.pub"))
+                           (append (list (local-file "../keys/twig-guix-signing-key.pub"))
                                    %default-authorized-guix-keys)))))

So basically I referenced a file that doesn't exist with local-file.

But why would that cause the string formatting to fail?  Dunno...

Christopher Lemmer Webber writes:

> Seems strange... the message I get:
>
>   guix deploy: error: failed to deploy tulsi: ~A: ~S
>
> Errors upon errors!  Formatting this time, apparently. :)
>
> Looking at the relevant code:
>
> (define (deploy-machine* store machine)
>   "Deploy MACHINE, taking care of error handling."
>   (info (G_ "deploying to ~a...~%")
>         (machine-display-name machine))
>
>   (guard (c ((message-condition? c)
>              (report-error (G_ "failed to deploy ~a: ~a~%")
>                            (machine-display-name machine)
>                            (condition-message c)))
>             ((deploy-error? c)
>              (when (deploy-error-should-roll-back c)
>                (info (G_ "rolling back ~a...~%")
>                      (machine-display-name machine))
>                (run-with-store store (roll-back-machine machine)))
>              (apply throw (deploy-error-captured-args c))))
>     (run-with-store store (deploy-machine machine))
>
>     (info (G_ "successfully deployed ~a~%")
>           (machine-display-name machine))))
>
> I looked at other examples of report-error, they seemed similar.. can't
> see why this one wouldn't be formatting correctly.  Any idea?